// Finds PIS Codes using DB Lookups

const db = require('../services/dbAccess.services');
const log = require('../utils/log.utils');
const clean = require('../utils/sanitizer.utils');

async function findPisByOrigDest(start,end) {
  log.out(`pisServices.findPisByOrigDest: Searching for PIS for Orig: ${start}, Dest: ${end}`, 'dbug');
  const firstCrs = clean.cleanApiEndpointTxt(start.toLowerCase());
  const lastCrs = clean.cleanApiEndpointTxt(end.toLowerCase());
  const query = {
    stops: {
      $all: [
        { $elemMatch: { $eq: firstCrs } },
        { $elemMatch: { $eq: lastCrs } }
      ]
    },
    $expr: {
      $and: [
        { $eq: [{ $arrayElemAt: [ '$stops', -1 ] }, lastCrs] },
        { $eq: [{ $arrayElemAt: [ '$stops', 0 ] }, firstCrs] }
      ]
    }
  };
  //const oldQuery = {$and:[{$expr:{$eq:[{$first:"$stops"},firstCrs]}},{$expr:{$eq:[{$last:"$stops"},lastCrs]}}]}
  const search = db.query('pis', query);
  return search;
}

// Hopefully at some point, I will also be able to implement a find PIS code by headcode option.

module.exports = {
  findPisByOrigDest
};